diff --git a/tests/Feature/Http/Controllers/Api/Auth/RegistrationControllerTest.php b/tests/Feature/Http/Controllers/Api/Auth/RegistrationControllerTest.php
new file mode 100644
index 0000000..eefbf25
--- /dev/null
+++ b/tests/Feature/Http/Controllers/Api/Auth/RegistrationControllerTest.php
@@ -0,0 +1,125 @@
+<?php
+
+namespace Tests\Feature\Http\Controllers\Api\Auth;
+
+use Tests\Feature\ApiTestCase;
+use Tests\MailTrap;
+use Portal\User;
+
+class RegistrationControllerTest extends ApiTestCase
+{
+    use MailTrap;
+
+    public function test_register_user_when_registration_is_disabled()
+    {
+        $this->setSettings([
+            'reg_enabled' => false
+        ]);
+
+        $this->postJson('api/register');
+
+        $this->assertResponseStatus(404);
+    }
+
+    public function test_register_user()
+    {
+        $this->setSettings([
+            'reg_enabled' => true,
+            'reg_email_confirmation' => false,
+            'registration.captcha.enabled' => false,
+            'tos' => false
+        ]);
+
+        $data = [
+            'email' => 'john.doe@test.com',
+            'username' => 'john.doe',
+            'password' => '123123',
+            'password_confirmation' => '123123'
+        ];
+
+        $this->postJson("/api/register", $data);
+
+        $expected = array_except($data, ['password', 'password_confirmation']);
+
+        $this->seeStatusCode(201)
+            ->seeJson([
+                'requires_email_confirmation' => false
+            ])
+            ->seeInDatabase('users', $expected);
+    }
+
+    public function test_register_user_with_email_confirmation()
+    {
+        $this->setSettings([
+            'reg_enabled' => true,
+            'reg_email_confirmation' => true,
+            'registration.captcha.enabled' => false,
+            'tos' => false
+        ]);
+
+        $data = [
+            'email' => 'john.doe@test.com',
+            'username' => 'john.doe',
+            'password' => '123123',
+            'password_confirmation' => '123123'
+        ];
+
+        $this->postJson("/api/register", $data);
+
+        $expected = array_except($data, ['password', 'password_confirmation']);
+
+        $this->seeStatusCode(201)
+            ->seeJson([
+                'requires_email_confirmation' => true
+            ])
+            ->seeInDatabase('users', $expected);
+
+        $token = User::where('email', $data['email'])->first()->confirmation_token;
+
+        $message = $this->fetchInbox()[0];
+
+        $this->assertEquals($data['email'], $message['to_email']);
+        $this->assertEquals(config('mail.from.address'), $message['from_email']);
+        $this->assertEquals(config('mail.from.name'), $message['from_name']);
+        $this->assertContains(
+            trans('app.thank_you_for_registering', ['app' => settings('app_name')]),
+            trim($message['html_body'])
+        );
+        $this->assertContains(
+            trans('app.confirm_email_on_link_below'),
+            trim($message['html_body'])
+        );
+        $this->assertContains(
+            route('register.confirm-email', $token),
+            trim($message['html_body'])
+        );
+
+        $this->emptyInbox();
+    }
+
+    public function test_register_with_tos()
+    {
+        $this->setSettings([
+            'reg_enabled' => true,
+            'reg_email_confirmation' => false,
+            'registration.captcha.enabled' => false,
+            'tos' => true
+        ]);
+
+        $data = [
+            'email' => 'john.doe@test.com',
+            'username' => 'john.doe',
+            'password' => '123123',
+            'password_confirmation' => '123123'
+        ];
+
+        $this->postJson("/api/register", $data);
+
+        $this->seeStatusCode(422)
+            ->seeJson([
+                'tos' => [
+                    trans('app.you_have_to_accept_tos')
+                ]
+            ]);
+    }
+}
diff --git a/tests/Feature/Http/Controllers/Api/Auth/SocialLoginControllerTest.php b/tests/Feature/Http/Controllers/Api/Auth/SocialLoginControllerTest.php
new file mode 100644
index 0000000..fdb446b
--- /dev/null
+++ b/tests/Feature/Http/Controllers/Api/Auth/SocialLoginControllerTest.php
@@ -0,0 +1,181 @@
+<?php
+
+namespace Tests\Feature\Http\Controllers\Api\Auth;
+
+use Laravel\Socialite\Two\FacebookProvider;
+use Tests\Feature\ApiTestCase;
+use Portal\Repositories\User\UserRepository;
+use Portal\Services\Auth\Api\Token;
+use Portal\Support\Enum\UserStatus;
+use Portal\User;
+use Mockery as m;
+use Laravel\Socialite\Contracts\User as SocialUserContract;
+
+class SocialLoginControllerTest extends ApiTestCase
+{
+    public function test_social_authentication_for_first_time()
+    {
+        $this->setSettings([
+            'reg_enabled' => true
+        ]);
+
+        $socialUser = new StubSocialUser;
+
+        $this->mockFacebookProvider($socialUser);
+
+        $this->postJson("/api/login/social", [
+            'network' => 'facebook',
+            'social_token' => 'foo'
+        ]);
+
+        $this->assertResponseOk();
+
+        $user = User::whereEmail($socialUser->getEmail())->first();
+
+        $token = Token::where('user_id', $user->id)->first();
+
+        $this->seeInDatabase('users', [
+            'first_name' => 'John',
+            'last_name' => 'Doe',
+            'email' => $socialUser->getEmail(),
+            'status' => UserStatus::ACTIVE,
+            'avatar' => $socialUser->getAvatar()
+        ]);
+
+        $this->seeInDatabase('social_logins', [
+            'user_id' => $user->id,
+            'provider' => 'facebook',
+            'provider_id' => $socialUser->getId(),
+            'avatar' => $socialUser->getAvatar()
+        ]);
+
+        $this->assertJwtTokenContains($token->id);
+    }
+
+    public function test_associate_social_account_with_existing_user()
+    {
+        $this->setSettings([
+            'reg_enabled' => true
+        ]);
+
+        $socialUser = new StubSocialUser;
+
+        $this->mockFacebookProvider($socialUser);
+
+        $user = factory(User::class)->create([
+            'email' => $socialUser->getEmail()
+        ]);
+
+        $this->postJson("/api/login/social", [
+            'network' => 'facebook',
+            'social_token' => 'foo'
+        ]);
+
+        $this->assertResponseOk();
+
+        $this->seeInDatabase('social_logins', [
+            'user_id' => $user->id,
+            'provider' => 'facebook',
+            'provider_id' => $socialUser->getId(),
+            'avatar' => $socialUser->getAvatar()
+        ]);
+
+        $token = Token::where('user_id', $user->id)->first();
+
+        $this->assertJwtTokenContains($token->id);
+    }
+
+    public function test_social_login_if_registration_is_disabled()
+    {
+        $this->setSettings([
+            'reg_enabled' => false
+        ]);
+
+        $socialUser = new StubSocialUser;
+
+        $this->mockFacebookProvider($socialUser);
+
+        $this->postJson("/api/login/social", [
+            'network' => 'facebook',
+            'social_token' => 'foo'
+        ]);
+
+        $this->assertResponseStatus(403)
+            ->seeJsonContains([
+                'error' => "Only users who already created an account can log in."
+            ]);
+    }
+
+    public function test_social_login_with_invalid_provider()
+    {
+        $this->postJson("/api/login/social", [
+            'network' => 'foo',
+            'social_token' => 'bar'
+        ]);
+
+        $this->assertResponseStatus(422)
+            ->seeJsonContains([
+                'network' => [trans('validation.in', ['attribute' => 'network'])]
+            ]);
+    }
+
+    public function test_social_login_for_banned_user()
+    {
+        $socialUser = new StubSocialUser;
+
+        $this->mockFacebookProvider($socialUser);
+
+        $user = factory(User::class)->create([
+            'email' => $socialUser->getEmail(),
+            'status' => UserStatus::BANNED
+        ]);
+
+        app(UserRepository::class)->associateSocialAccountForUser($user->id, 'facebook', $socialUser);
+
+        $this->postJson("/api/login/social", [
+            'network' => 'facebook',
+            'social_token' => 'foo'
+        ]);
+
+        $this->assertResponseStatus(403)
+            ->seeJsonContains([
+                'error' => 'Your account is banned by administrators.'
+            ]);
+    }
+
+    private function mockFacebookProvider($socialUser)
+    {
+        $provider = m::mock(FacebookProvider::class);
+        $provider->shouldReceive('userFromToken')->with('foo')->andReturn($socialUser);
+
+        \Socialite::shouldReceive('driver')->with('facebook')->andReturn($provider);
+    }
+}
+
+class StubSocialUser implements SocialUserContract
+{
+    public function getId()
+    {
+        return '123';
+    }
+
+    public function getNickname()
+    {
+        return 'johndoe';
+    }
+
+    public function getName()
+    {
+        return 'John Doe';
+    }
+
+    public function getEmail()
+    {
+        return 'john@doe.com';
+    }
+
+    public function getAvatar()
+    {
+        return 'http://www.gravatar.com/avatar';
+    }
+}
diff --git a/tests/Feature/Http/Controllers/Api/Authorization/PermissionsControllerTest.php b/tests/Feature/Http/Controllers/Api/Authorization/PermissionsControllerTest.php
new file mode 100644
index 0000000..27a04f0
--- /dev/null
+++ b/tests/Feature/Http/Controllers/Api/Authorization/PermissionsControllerTest.php
@@ -0,0 +1,190 @@
+<?php
+
+namespace Tests\Feature\Http\Controllers\Api\Authorization;
+
+use Tests\Feature\ApiTestCase;
+use Portal\Permission;
+use Portal\Transformers\PermissionTransformer;
+use Portal\User;
+
+class PermissionsControllerTest extends ApiTestCase
+{
+    public function test_unauthenticated()
+    {
+        $this->getJson('/api/permissions')
+            ->assertResponseStatus(401);
+    }
+
+    public function test_get_users_without_permission()
+    {
+        $user = factory(User::class)->create();
+
+        $this->actingAs($user, 'api')
+            ->getJson('/api/permissions')
+            ->assertResponseStatus(403);
+    }
+
+    public function test_get_permissions()
+    {
+        $this->getUser();
+
+        factory(Permission::class)->times(3)->create();
+
+        $this->getJson("/api/permissions");
+
+        $permissions = Permission::all();
+
+        $this->assertResponseOk()
+            ->seeJsonEquals(
+                $this->transformCollection($permissions, new PermissionTransformer)
+            );
+
+        $response = $this->decodeResponseJson();
+
+        // 7 default permissions + 3 newly created
+        $this->assertCount(10, $response);
+    }
+
+    public function test_get_permission()
+    {
+        $this->getUser();
+
+        $permission = factory(Permission::class)->create();
+
+        $this->getJson("/api/permissions/{$permission->id}");
+
+        $this->assertResponseOk()
+            ->seeJsonEquals(
+                (new PermissionTransformer)->transform($permission)
+            );
+    }
+
+    public function test_create_permission()
+    {
+        $this->getUser();
+
+        $data = [
+            'name' => 'foo',
+            'display_name' => 'Foo Permission',
+            'description' => 'This is foo permission.'
+        ];
+
+        $this->postJson("/api/permissions", $data);
+
+        $this->assertResponseOk()
+            ->seeInDatabase('permissions', $data)
+            ->seeJsonContains($data);
+    }
+
+    public function test_create_permission_with_invalid_name()
+    {
+        $this->getUser();
+
+        $this->postJson("/api/permissions");
+
+        $this->assertResponseStatus(422)
+            ->seeJsonContains([
+                'name' => [
+                    trans('validation.required', ['attribute' => 'name'])
+                ]
+            ]);
+
+        $existingPermission = Permission::first();
+
+        $this->postJson("/api/permissions", ['name' => $existingPermission->name]);
+
+        $this->assertResponseStatus(422)
+            ->seeJsonContains([
+                'name' => [
+                    trans('app.permission_already_exists')
+                ]
+            ]);
+
+        $this->postJson("/api/permissions", ['name' => 'foo bar']);
+
+        $this->assertResponseStatus(422)
+            ->seeJsonContains([
+                'name' => [
+                    trans('validation.regex', ['attribute' => 'name'])
+                ]
+            ]);
+    }
+
+    public function test_partially_update_permission()
+    {
+        $this->getUser();
+
+        $permission = factory(Permission::class)->create();
+
+        $data = ['name' => 'foo'];
+
+        $this->patchJson("/api/permissions/{$permission->id}", $data);
+
+        $expected = $data + ['id' => $permission->id];
+
+        $this->assertResponseOk()
+            ->seeInDatabase('permissions', $expected)
+            ->seeJsonContains($expected);
+    }
+
+    public function test_update_permission()
+    {
+        $this->getUser();
+
+        $permission = factory(Permission::class)->create();
+
+        $data = [
+            'name' => 'foo',
+            'display_name' => 'Foo Role',
+            'description' => 'This is foo role.'
+        ];
+
+        $this->patchJson("/api/permissions/{$permission->id}", $data);
+
+        $expected = $data + ['id' => $permission->id];
+
+        $this->assertResponseOk()
+            ->seeInDatabase('permissions', $expected)
+            ->seeJsonContains($expected);
+    }
+
+    public function test_remove_permission()
+    {
+        $this->getUser();
+
+        $permission = factory(Permission::class)->create([
+            'removable' => true
+        ]);
+
+        $this->deleteJson("/api/permissions/{$permission->id}");
+
+        $this->assertResponseOk()
+            ->seeJson(['success' => true])
+            ->dontSeeInDatabase('permissions', ['id' => $permission->id]);
+    }
+
+    public function test_remove_non_removable_permission()
+    {
+        $this->getUser();
+
+        $permission = factory(Permission::class)->create([
+            'removable' => false
+        ]);
+
+        $this->deleteJson("/api/permissions/{$permission->id}");
+
+        $this->seeStatusCode(403);
+    }
+
+    /**
+     * @return mixed
+     */
+    private function getUser()
+    {
+        $user = $this->login();
+
+        $this->addPermissionForUser($user, 'permissions.manage');
+
+        return $user;
+    }
+}
diff --git a/tests/Feature/Http/Controllers/Api/Authorization/RolePermissionsControllerTest.php b/tests/Feature/Http/Controllers/Api/Authorization/RolePermissionsControllerTest.php
new file mode 100644
index 0000000..5f1b363
--- /dev/null
+++ b/tests/Feature/Http/Controllers/Api/Authorization/RolePermissionsControllerTest.php
@@ -0,0 +1,90 @@
+<?php
+
+namespace Tests\Feature\Http\Controllers\Api\Authorization;
+
+use Tests\Feature\ApiTestCase;
+use Portal\Permission;
+use Portal\Role;
+use Portal\Transformers\PermissionTransformer;
+use Portal\User;
+
+class RolePermissionsControllerTest extends ApiTestCase
+{
+    public function test_unauthenticated()
+    {
+        $role = factory(Role::class)->create();
+
+        $this->getJson("/api/roles/{$role->id}/permissions")
+            ->assertResponseStatus(401);
+    }
+
+    public function test_get_settings_without_permission()
+    {
+        $role = factory(Role::class)->create();
+
+        $user = factory(User::class)->create();
+
+        $this->actingAs($user, 'api')
+            ->getJson("/api/roles/{$role->id}/permissions")
+            ->assertResponseStatus(403);
+    }
+
+    public function test_get_role_permissions()
+    {
+        $user = $this->getUser();
+
+        $role = factory(Role::class)->create();
+        $permission = factory(Permission::class)->create();
+
+        $role->attachPermission($permission);
+
+        $this->getJson("/api/roles/{$role->id}/permissions");
+
+        $this->assertResponseOk()
+            ->seeJsonEquals(
+                $this->transformCollection(collect([$permission]), new PermissionTransformer)
+            );
+    }
+
+    public function test_update_role_permissions()
+    {
+        $user = $this->getUser();
+
+        $role = factory(Role::class)->create();
+        $permissions1 = factory(Permission::class)->times(2)->create();
+        $permissions2 = factory(Permission::class)->times(3)->create();
+
+        $role->attachPermissions($permissions1);
+
+        $this->putJson("/api/roles/{$role->id}/permissions", [
+            'permissions' => $permissions2->pluck('id')
+        ]);
+
+        $this->assertResponseOk();
+
+        foreach ($permissions2 as $perm) {
+            $this->seeInDatabase('permission_role', [
+                'permission_id' => $perm->id,
+                'role_id' => $role->id
+            ]);
+        }
+
+        $this->seeJson(
+            $this->transformCollection($permissions2, new PermissionTransformer)
+        );
+    }
+
+    /**
+     * @return mixed
+     */
+    private function getUser()
+    {
+        $user = factory(User::class)->create();
+
+        $this->addPermissionForUser($user, 'permissions.manage');
+
+        $this->be($user, 'api');
+
+        return $user;
+    }
+}
diff --git a/tests/Feature/Http/Controllers/Api/Authorization/RolesControllerTest.php b/tests/Feature/Http/Controllers/Api/Authorization/RolesControllerTest.php
new file mode 100644
index 0000000..367cfc8
--- /dev/null
+++ b/tests/Feature/Http/Controllers/Api/Authorization/RolesControllerTest.php
@@ -0,0 +1,203 @@
+<?php
+
+namespace Tests\Feature\Http\Controllers\Api\Authorization;
+
+use Carbon\Carbon;
+use Illuminate\Support\Collection;
+use Tests\Feature\ApiTestCase;
+use Tests\Feature\FunctionalTestCase;
+use Portal\Country;
+use Portal\Role;
+use Portal\Services\Logging\UserActivity\Activity;
+use Portal\Support\Enum\UserStatus;
+use Portal\Transformers\ActivityTransformer;
+use Portal\Transformers\RoleTransformer;
+use Portal\Transformers\SessionTransformer;
+use Portal\Transformers\UserTransformer;
+use Portal\User;
+
+class RolesControllerTest extends ApiTestCase
+{
+    public function test_unauthenticated()
+    {
+        $this->getJson('/api/roles')
+            ->assertResponseStatus(401);
+    }
+
+    public function test_get_settings_without_permission()
+    {
+        $user = factory(User::class)->create();
+
+        $this->actingAs($user, 'api')
+            ->getJson('/api/roles')
+            ->assertResponseStatus(403);
+    }
+
+    public function test_get_roles()
+    {
+        $user = $this->getUser();
+
+        factory(Role::class)->times(4)->create();
+
+        $this->getJson("/api/roles");
+
+        $roles = Role::withCount('users')->get();
+
+        $this->assertResponseOk()
+            ->seeJsonEquals(
+                $this->transformCollection($roles, new RoleTransformer)
+            );
+
+        $response = $this->decodeResponseJson();
+
+        $this->assertCount(6, $response);
+    }
+
+    public function test_get_role()
+    {
+        $user = $this->getUser();
+
+        $userRole = Role::whereName('User')->first();
+
+        $this->getJson("/api/roles/{$userRole->id}");
+
+        $this->assertResponseOk()
+            ->seeJsonEquals(
+                (new RoleTransformer)->transform($userRole)
+            );
+    }
+
+    public function test_create_role()
+    {
+        $this->getUser();
+
+        $data = [
+            'name' => 'foo',
+            'display_name' => 'Foo Role',
+            'description' => 'This is foo role.'
+        ];
+
+        $this->postJson("/api/roles", $data);
+
+        $this->assertResponseOk()
+            ->seeInDatabase('roles', $data)
+            ->seeJsonContains($data);
+    }
+
+    public function test_create_role_with_invalid_name()
+    {
+        $this->getUser();
+
+        $this->postJson("/api/roles");
+
+        $this->assertResponseStatus(422)
+            ->seeJsonContains([
+                'name' => [
+                    trans('validation.required', ['attribute' => 'name'])
+                ]
+            ]);
+
+        $this->postJson("/api/roles", ['name' => 'User']);
+
+        $this->assertResponseStatus(422)
+            ->seeJsonContains([
+                'name' => [
+                    trans('validation.unique', ['attribute' => 'name'])
+                ]
+            ]);
+
+        $this->postJson("/api/roles", ['name' => 'foo bar']);
+
+        $this->assertResponseStatus(422)
+            ->seeJsonContains([
+                'name' => [
+                    trans('validation.regex', ['attribute' => 'name'])
+                ]
+            ]);
+    }
+
+    public function test_update_role()
+    {
+        $user = $this->getUser();
+
+        $data = ['name' => 'foo'];
+
+        $this->patchJson("/api/roles/{$user->role_id}", $data);
+
+        $expected = $data + ['id' => $user->role_id];
+
+        $this->assertResponseOk()
+            ->seeInDatabase('roles', $expected)
+            ->seeJsonContains($expected);
+    }
+
+    public function test_partially_update_role()
+    {
+        $user = $this->getUser();
+
+        $data = [
+            'name' => 'foo',
+            'display_name' => 'Foo Role',
+            'description' => 'This is foo role.'
+        ];
+
+        $this->actingAs($user, 'api')->patchJson("/api/roles/{$user->role_id}", $data);
+
+        $expected = $data + ['id' => $user->role_id];
+
+        $this->assertResponseOk()
+            ->seeInDatabase('roles', $expected)
+            ->seeJsonContains($expected);
+    }
+
+    public function test_remove_role()
+    {
+        $userRole = Role::whereName('User')->first();
+
+        $role = factory(Role::class)->create();
+
+        $user = factory(User::class)->create([
+            'role_id' => $role->id,
+        ]);
+
+        $this->addPermissionForUser($user, 'roles.manage');
+
+        $this->actingAs($user, 'api')->deleteJson("/api/roles/{$role->id}");
+
+        $this->seeStatusCode(200)
+            ->seeJson(['success' => true])
+            ->dontSeeInDatabase('roles', ['id' => $role->id])
+            ->assertEquals($userRole->id, $user->fresh()->role_id);
+    }
+
+    public function test_remove_non_removable_role()
+    {
+        $this->getUser();
+
+        $role = factory(Role::class)->create([
+            'removable' => false
+        ]);
+
+        $this->deleteJson("/api/roles/{$role->id}");
+
+        $this->seeStatusCode(403);
+    }
+
+    /**
+     * @return mixed
+     */
+    private function getUser()
+    {
+        $userRole = Role::whereName('User')->first();
+
+        $user = factory(User::class)->create([
+            'role_id' => $userRole->id,
+        ]);
+
+        $this->addPermissionForUser($user, 'roles.manage');
+
+        $this->be($user, 'api');
+
+        return $user;
+    }
+}
diff --git a/tests/Feature/Http/Controllers/Api/CountriesControllerTest.php b/tests/Feature/Http/Controllers/Api/CountriesControllerTest.php
new file mode 100644
index 0000000..888960d
--- /dev/null
+++ b/tests/Feature/Http/Controllers/Api/CountriesControllerTest.php
@@ -0,0 +1,31 @@
+<?php
+
+namespace Tests\Feature\Http\Controllers\Api;
+
+use Tests\Feature\ApiTestCase;
+use Portal\Country;
+use Portal\Transformers\CountryTransformer;
+
+class CountriesControllerTest extends ApiTestCase
+{
+    public function test_unauthenticated()
+    {
+        $this->getJson('/api/countries')
+            ->assertResponseStatus(401);
+    }
+
+    public function test_get_all_countries()
+    {
+        $this->login();
+
+        $this->getJson("/api/countries");
+
+        $transformed = $this->transformCollection(
+            Country::all(),
+            new CountryTransformer
+        );
+
+        $this->assertResponseOk()
+            ->seeJson($transformed);
+    }
+}
diff --git a/tests/Feature/Http/Controllers/Api/Profile/AvatarControllerTest.php b/tests/Feature/Http/Controllers/Api/Profile/AvatarControllerTest.php
new file mode 100644
index 0000000..0f2d35f
--- /dev/null
+++ b/tests/Feature/Http/Controllers/Api/Profile/AvatarControllerTest.php
@@ -0,0 +1,114 @@
+<?php
+
+namespace Tests\Feature\Http\Controllers\Api\Profile;
+
+use Illuminate\Http\UploadedFile;
+use Tests\Feature\ApiTestCase;
+
+class AvatarControllerTest extends ApiTestCase
+{
+    public function test_only_authenticated_user_can_update_avatar()
+    {
+        $this->putJson('/api/me/avatar');
+
+        $this->assertResponseStatus(401);
+    }
+
+    public function test_upload_avatar_image()
+    {
+        $this->login();
+
+        $file = UploadedFile::fake()->image('avatar.png', 500, 500);
+
+        $fileContent = file_get_contents($file->getRealPath());
+
+        $server = $this->transformHeadersToServerVars([
+            'Accept' => 'application/json',
+            'Content-Type' => 'image/jpeg'
+        ]);
+
+        $this->call('PUT', '/api/me/avatar', [], [], [], $server, $fileContent);
+
+        $response = $this->decodeResponseJson();
+
+        $this->seeStatusCode(200)
+            ->assertNotNull($response['avatar']);
+
+        $uploadedFile = str_replace(url(''), '', $response['avatar']);
+        $uploadedFile = public_path(ltrim($uploadedFile, "/"));
+
+        $this->assertFileExists($uploadedFile);
+
+        list($width, $height) = getimagesize($uploadedFile);
+
+        $this->assertEquals(160, $width);
+        $this->assertEquals(160, $height);
+
+        @unlink($uploadedFile);
+    }
+
+    public function test_upload_invalid_image()
+    {
+        $this->login();
+
+        $file = UploadedFile::fake()->create('avatar.png', 500);
+
+        $fileContent = file_get_contents($file->getRealPath());
+
+        $server = $this->transformHeadersToServerVars([
+            'Accept' => 'application/json',
+            'Content-Type' => 'image/jpeg'
+        ]);
+
+        $this->call('PUT', '/api/me/avatar', [], [], [], $server, $fileContent);
+
+        $this->seeStatusCode(422)
+            ->seeJsonContains([
+                'file' => [
+                    trans('validation.image', ['attribute' => 'file'])
+                ]
+            ]);
+    }
+
+    public function test_update_avatar_from_external_source()
+    {
+        $this->login();
+
+        $url = 'http://google.com';
+
+        $this->putJson('/api/me/avatar/external', [
+            'url' => $url
+        ]);
+
+        $this->assertResponseOk();
+        $this->seeJsonContains([
+            'avatar' => $url
+        ]);
+    }
+
+    public function test_update_avatar_with_invalid_external_source()
+    {
+        $this->login();
+
+        $this->putJson('/api/me/avatar/external', [
+            'url' => 'foo'
+        ]);
+
+        $this->assertResponseStatus(422);
+    }
+
+    public function test_delete_avatar()
+    {
+        $user = $this->login();
+
+        $user->forceFill([
+            'avatar' => 'http://google.com'
+        ])->save();
+
+        $this->deleteJson("api/me/avatar")
+            ->assertResponseOk()
+            ->seeJsonContains([
+                'avatar' => url('assets/img/profile.png') // default profile image
+            ]);
+    }
+}
diff --git a/tests/Feature/Http/Controllers/Api/Profile/DetailsControllerTest.php b/tests/Feature/Http/Controllers/Api/Profile/DetailsControllerTest.php
new file mode 100644
index 0000000..a88fccc
--- /dev/null
+++ b/tests/Feature/Http/Controllers/Api/Profile/DetailsControllerTest.php
@@ -0,0 +1,125 @@
+<?php
+
+namespace Tests\Feature\Http\Controllers\Api\Profile;
+
+use Carbon\Carbon;
+use Tests\Feature\ApiTestCase;
+use Portal\Transformers\UserTransformer;
+
+class DetailsControllerTest extends ApiTestCase
+{
+    public function test_get_user_profile_unauthenticated()
+    {
+        $this->getJson('/api/me')
+            ->assertResponseStatus(401);
+    }
+
+    public function test_get_user_profile()
+    {
+        $user = $this->login();
+
+        $transformed = (new UserTransformer)->transform($user);
+
+        $this->getJson('/api/me')
+            ->seeStatusCode(200)
+            ->seeJson($transformed);
+    }
+
+    public function test_update_user_profile_unauthenticated()
+    {
+        $this->patchJson('/api/me/details')
+            ->assertResponseStatus(401);
+    }
+
+    public function test_update_user_profile()
+    {
+        $user = $this->login();
+
+        $data = $this->getData();
+
+        $this->patchJson("/api/me/details", $data);
+
+        $transformed = (new UserTransformer)->transform($user->fresh());
+
+        $this->seeJson($transformed);
+
+        $this->seeInDatabase('users', array_merge($data, [
+            'id' => $user->id
+        ]));
+    }
+
+    public function test_partially_update_user_details()
+    {
+        $user = $this->login();
+
+        $data = [
+            'first_name' => 'John',
+            'last_name'  => 'Doe'
+        ];
+
+        $this->patchJson("/api/me/details", $data);
+
+        $transformed = (new UserTransformer)->transform($user->fresh());
+
+        $this->seeJson($transformed);
+
+        $this->seeInDatabase('users', array_merge($data, [
+            'id' => $user->id,
+            'birthday' => $user->birthday->format('Y-m-d'),
+            'phone' => $user->phone,
+            'address' => $user->address,
+            'country_id' => $user->country_id,
+        ]));
+    }
+
+    public function test_update_without_country_id()
+    {
+        $user = $this->login();
+
+        $data = $this->getData();
+
+        unset($data['country_id']);
+
+        $this->patchJson("/api/me/details", $data);
+
+        $transformed = (new UserTransformer)->transform($user->fresh());
+
+        $this->seeJson($transformed);
+
+        $this->seeInDatabase('users', array_merge($data, [
+            'id' => $user->id
+        ]));
+    }
+
+    public function test_update_with_invalid_date_format()
+    {
+        $this->login();
+
+        $this->patchJson("/api/me/details", [
+            'birthday' => 'foo'
+        ]);
+
+        $this->assertResponseStatus(422);
+
+        $this->seeJson([
+            'birthday' => [
+                trans('validation.date', ['attribute' => 'birthday'])
+            ]
+        ]);
+    }
+
+    /**
+     * @return array
+     */
+    private function getData(array $attrs = [])
+    {
+        return array_merge([
+            'first_name' => 'John',
+            'last_name'  => 'Doe',
+            'birthday'   => Carbon::now()->subYears(25)->format('Y-m-d'),
+            'phone'      => '(123) 456 789',
+            'address'    => 'some address 1',
+            'country_id' => 688,
+        ], $attrs);
+    }
+}
